From ae7b71271ee60896ab8a378866e7cddbbd46d00a Mon Sep 17 00:00:00 2001
From: Daniel Gustafsson <daniel@yesql.se>
Date: Thu, 9 Jul 2026 15:50:18 +0200
Subject: [PATCH vPoC] ssl: Split OpenSSL and LibreSSL into separate modules

LibreSSL support in PostgreSQL was added more as a consequence of the
OpenSSL compatibility of LibreSSL than a discussed library dependency.
Support for LibreSSL was in the beginning undocumented with no minimum
version specified.  The OpenSSL code in libpq handled the differences
with ifdefs.

As we are looking to deprecate support for OpenSSL 1.1.1 and modernize
our OpenSSL code with 3.0+ APIs, we need to separate support for the
libraries since LibreSSL still use the 1.1.1 style API.  If we keep the
support in the same file it will hurt readability with all the ifdefs
required, and risk hampering efforts to make use of modern OpenSSL API
features.  The recent support for serverside SNI is another example
where mixing the APIs caused problems, which ended up with serverside
SNI not being available when building with LibreSSL.

This copies the current OpenSSL support into mirrored LibreSSL files
and removes the compatibility fixes from both, with no new features
introduced.

There are still a few more things needed to take this patch from POC
status, some are listed below:

  TODO
    - Autoconf support is a POC and not tested yet
	- include/common/openssl.h needs to either be renamed, copied
	  or at least have its comments extended
	- test/ssl/t/SSL/Backend/OpenSSL.pm has been hackily extended
	  for now, the exact level of changes required here are not
	  clear, and a future move to pytest may influence how much we
	  want to invest here
---
 configure                                 |  112 +-
 configure.ac                              |   15 +-
 meson.build                               |   61 +-
 meson_options.txt                         |    4 +-
 src/backend/commands/variable.c           |    2 +-
 src/backend/libpq/Makefile                |    3 +
 src/backend/libpq/be-secure-libressl.c    | 1978 +++++++++++++++++++++
 src/backend/libpq/be-secure-openssl.c     |   97 +-
 src/backend/libpq/meson.build             |    6 +-
 src/include/common/openssl.h              |    4 +-
 src/include/libpq/libpq-be.h              |    8 +-
 src/include/libpq/libpq.h                 |    6 +-
 src/include/pg_config.h.in                |   20 +-
 src/include/pg_config_manual.h            |    2 +-
 src/interfaces/libpq/Makefile             |    4 +
 src/interfaces/libpq/fe-secure-libressl.c | 1905 ++++++++++++++++++++
 src/interfaces/libpq/fe-secure-openssl.c  |   22 +-
 src/interfaces/libpq/fe-secure.c          |    7 +-
 src/interfaces/libpq/libpq-int.h          |    8 +-
 src/interfaces/libpq/meson.build          |    6 +-
 src/port/pg_strong_random.c               |    4 +-
 src/test/ssl/t/001_ssltests.pl            |    4 +-
 src/test/ssl/t/002_scram.pl               |    4 +-
 src/test/ssl/t/003_sslinfo.pl             |    4 +-
 src/test/ssl/t/004_sni.pl                 |   11 +-
 src/test/ssl/t/SSL/Backend/OpenSSL.pm     |    4 +-
 src/test/ssl/t/SSL/Server.pm              |    5 +
 27 files changed, 4105 insertions(+), 201 deletions(-)
 create mode 100644 src/backend/libpq/be-secure-libressl.c
 create mode 100644 src/interfaces/libpq/fe-secure-libressl.c

diff --git a/configure.ac b/configure.ac
index 0e624fe36b9..a5357d1d2a5 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1420,7 +1420,7 @@ fi
 #
 # SSL Library
 #
-# There is currently only one supported SSL/TLS library: OpenSSL.
+# The currently supported SSL/TLS libraries are: OpenSSL, LibreSSL
 #
 PGAC_ARG_REQ(with, ssl, [LIB], [use LIB for SSL/TLS support (openssl)])
 if test x"$with_ssl" = x"" ; then
@@ -1440,13 +1440,16 @@ if test "$with_ssl" = openssl ; then
   AC_CHECK_LIB(ssl,    SSL_new, [], [AC_MSG_ERROR([library 'ssl' is required for OpenSSL])])
   # Functions introduced in OpenSSL 1.1.1.
   AC_CHECK_FUNCS([SSL_CTX_set_ciphersuites], [], [AC_MSG_ERROR([OpenSSL version >= 1.1.1 is required for SSL support])])
-  # Function introduced in OpenSSL 1.0.2, not in LibreSSL.
-  AC_CHECK_FUNCS([SSL_CTX_set_cert_cb])
-  # Function introduced in OpenSSL 1.1.1, not in LibreSSL.
-  AC_CHECK_FUNCS([X509_get_signature_info SSL_CTX_set_num_tickets SSL_CTX_set_keylog_callback SSL_CTX_set_client_hello_cb])
   AC_DEFINE([USE_OPENSSL], 1, [Define to 1 to build with OpenSSL support. (--with-ssl=openssl)])
+elif test "$with_ssl" = libressl ; then
+  dnl Order matters!
+  AC_CHECK_LIB(crypto, CRYPTO_new_ex_data, [], [AC_MSG_ERROR([library 'crypto' is required for LibreSSL])])
+  AC_CHECK_LIB(ssl,    SSL_new, [], [AC_MSG_ERROR([library 'ssl' is required for LibreSSL])])
+  # Functions introduced in LibreSSL 3.4.1 (OpenBSD 7.0)
+  AC_CHECK_FUNCS([SSL_CTX_set_ciphersuites SSL_CTX_use_certificate_chain_mem], [], [AC_MSG_ERROR([LibreSSL version >= 3.4.1 is required for SSL support])])
+  AC_DEFINE([USE_LIBRESSL], 1, [Define to 1 to build with LibreSSL support. (--with-ssl=libressl)])
 elif test "$with_ssl" != no ; then
-  AC_MSG_ERROR([--with-ssl must specify openssl])
+  AC_MSG_ERROR([--with-ssl must specify openssl or libressl])
 fi
 AC_SUBST(with_ssl)
 
diff --git a/meson.build b/meson.build
index d88a7a70308..c84b68f999c 100644
--- a/meson.build
+++ b/meson.build
@@ -1627,8 +1627,8 @@ if sslopt == 'auto' and auto_features.disabled()
   sslopt = 'none'
 endif
 
-if sslopt in ['auto', 'openssl']
-  openssl_required = (sslopt == 'openssl')
+if sslopt in ['auto', 'openssl', 'libressl']
+  ssl_library_required = (sslopt != 'auto')
 
   # Try to find openssl via pkg-config et al, if that doesn't work
   # (e.g. because it's provided as part of the OS, like on FreeBSD), look for
@@ -1646,16 +1646,16 @@ if sslopt in ['auto', 'openssl']
       dirs: test_lib_d,
       header_include_directories: postgres_inc,
       has_headers: ['openssl/ssl.h', 'openssl/err.h'],
-      required: openssl_required)
+      required: ssl_library_required)
     crypto_lib = cc.find_library('crypto',
       dirs: test_lib_d,
-      required: openssl_required)
+      required: ssl_library_required)
     if ssl_lib.found() and crypto_lib.found()
       ssl_int = [ssl_lib, crypto_lib]
       ssl = declare_dependency(dependencies: ssl_int, include_directories: postgres_inc)
     endif
-  elif cc.has_header('openssl/ssl.h', args: test_c_args, dependencies: ssl, required: openssl_required) and \
-       cc.has_header('openssl/err.h', args: test_c_args, dependencies: ssl, required: openssl_required)
+  elif cc.has_header('openssl/ssl.h', args: test_c_args, dependencies: ssl, required: ssl_library_required) and \
+       cc.has_header('openssl/err.h', args: test_c_args, dependencies: ssl, required: ssl_library_required)
     ssl_int = [ssl]
   else
     ssl = not_found_dep
@@ -1666,41 +1666,52 @@ if sslopt in ['auto', 'openssl']
       ['CRYPTO_new_ex_data', {'required': true}],
       ['SSL_new', {'required': true}],
 
-      # Functions introduced in OpenSSL 1.1.1.
+      # Functions introduced in OpenSSL 1.1.1 and present in LibreSSL
       ['SSL_CTX_set_ciphersuites', {'required': true}],
 
+      # Functions for optionally supported functionality in OpenSSL
+      ['SSL_CTX_set_keylog_callback', {'optional': true}],
+
       # Function introduced in OpenSSL 1.0.2, not in LibreSSL.
-      ['SSL_CTX_set_cert_cb'],
+      ['SSL_CTX_set_cert_cb', {'openssl': true}],
 
-      # Function introduced in OpenSSL 1.1.1, not in LibreSSL.
-      ['X509_get_signature_info'],
-      ['SSL_CTX_set_num_tickets'],
-      ['SSL_CTX_set_keylog_callback'],
-      ['SSL_CTX_set_client_hello_cb'],
+      # Function present in LibreSSL 3.4, not in OpenSSL
+      ['SSL_CTX_use_certificate_chain_mem', {'libressl': true}],
     ]
 
-    are_openssl_funcs_complete = true
+    are_ssl_funcs_complete = true
     foreach c : check_funcs
       func = c.get(0)
       val = cc.has_function(func, args: test_c_args, dependencies: ssl_int)
       required = c.get(1, {}).get('required', false)
+      optional = c.get(1, {}).get('optional', false)
+      openssl_lib = c.get(1, {}).get('openssl', false)
+      libressl_lib = c.get(1, {}).get('libressl', false)
       if required and not val
-        are_openssl_funcs_complete = false
-        if openssl_required
-          error('openssl function @0@ is required'.format(func))
+        are_ssl_funcs_complete = false
+        if ssl_library_required
+          error('ssl function @0@ is required'.format(func))
         endif
         break
-      elif not required
+      elif optional
         cdata.set('HAVE_' + func.to_upper(), val ? 1 : false)
+      elif openssl_lib and val
+        ssl_library = 'openssl'
+      elif libressl_lib and val
+        ssl_library = 'libressl'
       endif
     endforeach
 
-    if are_openssl_funcs_complete
-      cdata.set('USE_OPENSSL', 1,
-                description: 'Define to 1 to build with OpenSSL support. (-Dssl=openssl)')
-      cdata.set('OPENSSL_API_COMPAT', '0x10101000L',
-                description: 'Define to the OpenSSL API version in use. This avoids deprecation warnings from newer OpenSSL versions.')
-      ssl_library = 'openssl'
+    if are_ssl_funcs_complete
+      if sslopt == 'openssl' and ssl_library == 'openssl'
+        cdata.set('USE_OPENSSL', 1,
+                  description: 'Define to 1 to build with OpenSSL support. (-Dssl=openssl)')
+        cdata.set('OPENSSL_API_COMPAT', '0x10101000L',
+                  description: 'Define to the OpenSSL API version in use. This avoids deprecation warnings from newer OpenSSL versions.')
+      elif sslopt == 'libressl' and ssl_library == 'libressl'
+        cdata.set('USE_LIBRESSL', 1,
+                  description: 'Define to 1 to build with LibreSSL support. (-Dssl=libressl)')
+      endif
     else
       ssl = not_found_dep
     endif
@@ -4331,13 +4342,13 @@ summary(
     'llvm': llvm,
     'lz4': lz4,
     'nls': libintl,
-    'openssl': ssl,
     'pam': pam,
     'plperl': [perl_dep, perlversion],
     'plpython': python3_dep,
     'pltcl': tcl_dep,
     'readline': readline,
     'selinux': selinux,
+    'ssl': [ssl_library, ssl],
     'systemd': systemd,
     'uuid': uuid,
     'zlib': zlib,
diff --git a/src/backend/commands/variable.c b/src/backend/commands/variable.c
index 8afd252fc8c..19102147945 100644
--- a/src/backend/commands/variable.c
+++ b/src/backend/commands/variable.c
@@ -1268,7 +1268,7 @@ check_ssl_sni(bool *newval, void **extra, GucSource source)
 		return false;
 	}
 #else
-#ifndef HAVE_SSL_CTX_SET_CLIENT_HELLO_CB
+#ifdef USE_LIBRESSL
 	if (*newval)
 	{
 		GUC_check_errmsg("SNI requires OpenSSL 1.1.1 or later");
diff --git a/src/backend/libpq/Makefile b/src/backend/libpq/Makefile
index 98eb2a8242d..655737454f8 100644
--- a/src/backend/libpq/Makefile
+++ b/src/backend/libpq/Makefile
@@ -33,6 +33,9 @@ OBJS = \
 ifeq ($(with_ssl),openssl)
 OBJS += be-secure-openssl.o
 endif
+ifeq ($(with_ssl),libressl)
+OBJS += be-secure-libressl.o
+endif
 
 ifeq ($(with_gssapi),yes)
 OBJS += be-gssapi-common.o be-secure-gssapi.o
